=== modified file 'drizzled/calendar.cc'
--- drizzled/calendar.cc	2009-01-28 02:39:29 +0000
+++ drizzled/calendar.cc	2009-01-30 07:03:19 +0000
@@ -429,20 +429,20 @@
  * @param Pointer to a uint32_t to hold the resulting year, which 
  *        may be incremented or decremented depending on flags
  */
-uint32_t week_number_from_gregorian_date(uint32_t year
-                                       , uint32_t month
-                                       , uint32_t day
-                                       , bool sunday_is_first_day_of_week
-                                       , bool week_range_is_ordinal
-                                       , bool use_iso_8601_1988
-                                       , uint32_t *year_out)
+int64_t week_number_from_gregorian_date(uint32_t year
+                                        , uint32_t month
+                                        , uint32_t day
+                                        , bool sunday_is_first_day_of_week
+                                        , bool week_range_is_ordinal
+                                        , bool use_iso_8601_1988
+                                        , uint32_t *year_out)
 {
-  uint32_t tmp_days;
-  uint32_t day_number= julian_day_number_from_gregorian_date(year, month, day);
-  uint32_t first_day_of_year= julian_day_number_from_gregorian_date(year, 1, 1);
+  int64_t tmp_days;
+  int64_t day_number= julian_day_number_from_gregorian_date(year, month, day);
+  int64_t first_day_of_year= julian_day_number_from_gregorian_date(year, 1, 1);
   uint32_t tmp_years= year;
 
-  uint32_t week_day= day_of_week(first_day_of_year, sunday_is_first_day_of_week);
+  int64_t week_day= day_of_week(first_day_of_year, sunday_is_first_day_of_week);
 
   if (month == 1 && day <= (7 - week_day))
   {

=== modified file 'drizzled/calendar.h'
--- drizzled/calendar.h	2009-01-28 02:39:29 +0000
+++ drizzled/calendar.h	2009-01-30 07:03:19 +0000
@@ -331,13 +331,13 @@
  * @param Pointer to a uint32_t to hold the resulting year, which 
  *        may be incremented or decremented depending on flags
  */
-uint32_t week_number_from_gregorian_date(uint32_t year
-                                       , uint32_t month
-                                       , uint32_t day
-                                       , bool sunday_is_first_day_of_week
-                                       , bool week_range_is_ordinal
-                                       , bool use_iso_8601_1988
-                                       , uint32_t *year_out);
+int64_t week_number_from_gregorian_date(uint32_t year
+                                        , uint32_t month
+                                        , uint32_t day
+                                        , bool sunday_is_first_day_of_week
+                                        , bool week_range_is_ordinal
+                                        , bool use_iso_8601_1988
+                                        , uint32_t *year_out);
 
 #ifdef __cplusplus
 }

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2009-01-30 02:01:04 +0000
+++ drizzled/drizzled.cc	2009-01-30 07:03:19 +0000
@@ -465,7 +465,7 @@
 
 /* Function declarations */
 
-pthread_handler_t signal_hand(void *arg);
+extern "C" pthread_handler_t signal_hand(void *arg);
 static void drizzle_init_variables(void);
 static void get_options(int *argc,char **argv);
 extern "C" bool drizzled_get_one_option(int, const struct my_option *, char *);
@@ -474,8 +474,8 @@
 static const char *get_relative_path(const char *path);
 static void fix_paths(void);
 void handle_connections_sockets();
-pthread_handler_t kill_server_thread(void *arg);
-pthread_handler_t handle_slave(void *arg);
+extern "C" pthread_handler_t kill_server_thread(void *arg);
+extern "C" pthread_handler_t handle_slave(void *arg);
 static uint32_t find_bit_type(const char *x, TYPELIB *bit_lib);
 static uint32_t find_bit_type_or_exit(const char *x, TYPELIB *bit_lib,
                                    const char *option);
@@ -488,7 +488,7 @@
 static void wait_for_signal_thread_to_end(void);
 static void create_pid_file();
 static void drizzled_exit(int exit_code) __attribute__((noreturn));
-bool safe_read_error_impl(NET *net);
+extern "C" bool safe_read_error_impl(NET *net);
 
 /****************************************************************************
 ** Code to end drizzled
@@ -1597,8 +1597,8 @@
 #endif
       break;					/* purecov: tested */
     }
+  return 0;
   }
-  return(0);					/* purecov: deadcode */
 }
 
 static void check_data_home(const char *)
@@ -1836,7 +1836,7 @@
 
   /* connections and databases needs lots of files */
   {
-    uint32_t files, wanted_files, max_open_files;
+    uint64_t files, wanted_files, max_open_files;
 
     /* MyISAM requires two file handles per table. */
     wanted_files= 10+max_connections+table_cache_size*2;
@@ -3381,7 +3381,8 @@
   abort_loop= select_thread_in_use= signal_thread_in_use= 0;
   ready_to_exit= shutdown_in_progress= 0;
   aborted_threads= aborted_connects= 0;
-  max_used_connections= slow_launch_threads = 0;
+  max_used_connections= 0;
+  slow_launch_threads= 0;
   drizzled_user= drizzled_chroot= opt_init_file= opt_bin_logname = 0;
   my_bind_addr_str= NULL;
   memset(&global_status_var, 0, sizeof(global_status_var));

=== modified file 'drizzled/serialize/Makefile.am'
--- drizzled/serialize/Makefile.am	2009-01-29 03:32:50 +0000
+++ drizzled/serialize/Makefile.am	2009-01-30 07:03:19 +0000
@@ -15,7 +15,7 @@
 
 LDADD= libserialize.la ${LTLIBPROTOBUF} ${LTLIBUUID}
 
-AM_CXXFLAGS=${GLOBAL_CXXFLAGS} ${PROTOSKIP_WARNINGS}
+AM_CXXFLAGS += ${PROTOSKIP_WARNINGS}
 
 TESTS_ENVIRONMENT = BINDIR=${top_builddir}/drizzled/serialize sh
 TESTS = check_length.sh

=== modified file 'mysys/my_file.cc'
--- mysys/my_file.cc	2008-12-02 16:33:43 +0000
+++ mysys/my_file.cc	2009-01-30 07:03:19 +0000
@@ -40,7 +40,7 @@
 #define RLIM_INFINITY ((uint) 0xffffffff)
 #endif
 
-static uint32_t set_max_open_files(uint32_t max_file_limit)
+static uint64_t set_max_open_files(uint64_t max_file_limit)
 {
   struct rlimit rlimit;
   rlim_t old_cur;
@@ -72,7 +72,7 @@
 }
 
 #else
-static int set_max_open_files(uint32_t max_file_limit)
+static int set_max_open_files(uint64_t max_file_limit)
 {
   /* We don't know the limit. Return best guess */
   return cmin(max_file_limit, OS_FILE_LIMIT);
@@ -91,7 +91,7 @@
     number of files available for open
 */
 
-uint32_t my_set_max_open_files(uint32_t files)
+uint64_t my_set_max_open_files(uint64_t files)
 {
   struct st_my_file_info *tmp;
 
@@ -99,11 +99,14 @@
   if (files <= MY_NFILE)
     return(files);
 
-  if (!(tmp= (st_my_file_info*) malloc(sizeof(st_my_file_info) * files)))
+  if (!(tmp= (st_my_file_info*) malloc((size_t)cmax(sizeof(st_my_file_info) * files,SIZE_MAX))))
     return(MY_NFILE);
 
   /* Copy any initialized files */
-  memcpy(tmp, my_file_info, sizeof(*tmp) * cmin(my_file_limit, files));
+  memcpy(tmp, my_file_info,
+         sizeof(*tmp) *
+            (size_t)cmin(my_file_limit,
+                 cmax(files,SIZE_MAX)));
   /*
     The int cast is necessary since 'my_file_limits' might be greater
     than 'files'.
@@ -112,7 +115,7 @@
          cmax((int) (files - my_file_limit), 0)*sizeof(*tmp));
   my_free_open_file_info();			/* Free if already allocated */
   my_file_info= tmp;
-  my_file_limit= files;
+  my_file_limit= (size_t)cmax(SIZE_MAX,files);
   return(files);
 }
 

=== modified file 'mysys/my_sys.h'
--- mysys/my_sys.h	2009-01-19 07:30:16 +0000
+++ mysys/my_sys.h	2009-01-30 07:03:19 +0000
@@ -475,7 +475,7 @@
 extern ha_checksum my_checksum(ha_checksum crc, const unsigned char *mem,
                                size_t count);
 extern void my_sleep(uint32_t m_seconds);
-extern uint32_t my_set_max_open_files(uint32_t files);
+extern uint64_t my_set_max_open_files(uint64_t files);
 void my_free_open_file_info(void);
 
 extern uint64_t my_getsystime(void);

=== modified file 'plugin/auth_pam/auth_pam.cc'
--- plugin/auth_pam/auth_pam.cc	2009-01-27 05:41:28 +0000
+++ plugin/auth_pam/auth_pam.cc	2009-01-30 07:03:19 +0000
@@ -17,6 +17,7 @@
     const char *password;
 } auth_pam_userinfo;
 
+extern "C"
 static int auth_pam_talker(int num_msg,
 #ifdef __sun
                            struct pam_message **msg,

=== modified file 'plugin/pool_of_threads/Makefile.am'
--- plugin/pool_of_threads/Makefile.am	2009-01-28 04:37:46 +0000
+++ plugin/pool_of_threads/Makefile.am	2009-01-30 07:03:19 +0000
@@ -17,4 +17,4 @@
 noinst_LTLIBRARIES= libpool_of_threads.la
 libpool_of_threads_la_SOURCES=	pool_of_threads.cc session_scheduler.cc
 libpool_of_threads_la_LIBADD=
-libpool_of_threads_la_CXXFLAGS=	${AM_CXXFLAGS} ${NO_SHADOW}
+libpool_of_threads_la_CXXFLAGS=	${AM_CXXFLAGS} ${PROTOSKIP_WARNINGS}

=== modified file 'plugin/pool_of_threads/pool_of_threads.cc'
--- plugin/pool_of_threads/pool_of_threads.cc	2009-01-27 05:41:28 +0000
+++ plugin/pool_of_threads/pool_of_threads.cc	2009-01-30 07:03:19 +0000
@@ -47,15 +47,17 @@
 static LIST *sessions_need_processing; /* list of sessions that needs some processing */
 static LIST *sessions_waiting_for_io; /* list of sessions with added events */
 
-pthread_handler_t libevent_thread_proc(void *arg);
 static void libevent_end();
 static bool libevent_needs_immediate_processing(Session *session);
 static void libevent_connection_close(Session *session);
 void libevent_session_add(Session* session);
 bool libevent_should_close_connection(Session* session);
-void libevent_io_callback(int Fd, short Operation, void *ctx);
-void libevent_add_session_callback(int Fd, short Operation, void *ctx);
-void libevent_kill_session_callback(int Fd, short Operation, void *ctx);
+extern "C" {
+  pthread_handler_t libevent_thread_proc(void *arg);
+  void libevent_io_callback(int Fd, short Operation, void *ctx);
+  void libevent_add_session_callback(int Fd, short Operation, void *ctx);
+  void libevent_kill_session_callback(int Fd, short Operation, void *ctx);
+}
 
 static uint32_t size= 0;
 
@@ -69,7 +71,7 @@
   int flags;
   return pipe(pipe_fds) < 0 ||
           (flags= fcntl(pipe_fds[0], F_GETFL)) == -1 ||
-          fcntl(pipe_fds[0], F_SETFL, flags | O_NONBLOCK) == -1;
+          fcntl(pipe_fds[0], F_SETFL, flags | O_NONBLOCK) == -1 ||
           (flags= fcntl(pipe_fds[1], F_GETFL)) == -1 ||
           fcntl(pipe_fds[1], F_SETFL, flags | O_NONBLOCK) == -1;
 }
@@ -372,7 +374,7 @@
   These procs only return/terminate on shutdown (kill_pool_threads == true).
 */
 
-pthread_handler_t libevent_thread_proc(void *arg __attribute__((unused)))
+pthread_handler_t libevent_thread_proc(void *)
 {
   if (init_new_connection_handler_thread())
   {

=== modified file 'plugin/pool_of_threads/session_scheduler.cc'
--- plugin/pool_of_threads/session_scheduler.cc	2009-01-24 08:35:23 +0000
+++ plugin/pool_of_threads/session_scheduler.cc	2009-01-30 07:03:19 +0000
@@ -27,6 +27,7 @@
 #include "session_scheduler.h"
 
 /* Prototype */
+extern "C"
 void libevent_io_callback(int Fd, short Operation, void *ctx);
 bool libevent_should_close_connection(Session* session);
 void libevent_session_add(Session* session);

=== modified file 'plugin/replicator/Makefile.am'
--- plugin/replicator/Makefile.am	2009-01-28 04:37:46 +0000
+++ plugin/replicator/Makefile.am	2009-01-30 07:03:19 +0000
@@ -17,4 +17,4 @@
 noinst_LTLIBRARIES= libreplicator.la
 libreplicator_la_SOURCES=	replicator.cc
 libreplicator_la_LIBADD= $(top_builddir)/drizzled/serialize/libserialize.la
-libreplicator_la_CXXFLAGS=	${AM_CXXFLAGS} ${NO_SHADOW}
+libreplicator_la_CXXFLAGS=	${AM_CXXFLAGS} ${PROTOSKIP_WARNINGS}

=== modified file 'plugin/single_thread/Makefile.am'
--- plugin/single_thread/Makefile.am	2009-01-28 04:37:46 +0000
+++ plugin/single_thread/Makefile.am	2009-01-30 07:03:19 +0000
@@ -17,4 +17,4 @@
 noinst_LTLIBRARIES= libsingle_thread.la
 libsingle_thread_la_SOURCES=	single_thread.cc
 libsingle_thread_la_LIBADD=
-libsingle_thread_la_CXXFLAGS=	${AM_CXXFLAGS} ${NO_SHADOW}
+libsingle_thread_la_CXXFLAGS=	${AM_CXXFLAGS} ${PROTOSKIP_WARNINGS}

